> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pnbr.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Explore context

> Explore the project context around a question or entity.

**Operation ID:** `http.context.explore`

```http theme={null}
POST /v1/orgs/{org}/projects/{project}/context/explore
```


## OpenAPI

````yaml openapi.json POST /v1/orgs/{org}/projects/{project}/context/explore
openapi: 3.1.0
info:
  title: Penumbra API
  version: v1
  description: >-
    HTTP reference for Files, search, extraction, reviews, Graph, Shapes and
    sharing.
servers:
  - url: https://api.pnbr.io
    description: Penumbra API
security: []
paths:
  /v1/orgs/{org}/projects/{project}/context/explore:
    post:
      tags:
        - Search and citations
      summary: Explore context
      description: >-
        Explore the project context around a question or entity.


        Product guidance: [Search](/concepts/search), [Passage and
        citation](/concepts/passage), [Context](/concepts/context).
      operationId: http.context.explore
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: project
          in: path
          required: true
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/http_context_explore_request'
      responses:
        2XX:
          description: Success.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/http_context_explore_response'
      security:
        - bearerAuth: []
components:
  schemas:
    http_context_explore_request:
      type: object
      properties:
        mode:
          type: string
          enum:
            - overview
            - query
        query:
          type: string
          maxLength: 2048
        filters:
          default:
            shape_ids: []
            entity_types: []
            relationship_types: []
            file_ids: []
            file_shapes: []
          type: object
          properties:
            shape_ids:
              default: []
              maxItems: 32
              type: array
              items:
                type: string
                format: uuid
                pattern: >-
                  ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
            entity_types:
              default: []
              maxItems: 64
              type: array
              items:
                type: string
                minLength: 1
                maxLength: 256
            relationship_types:
              default: []
              maxItems: 64
              type: array
              items:
                type: string
                minLength: 1
                maxLength: 256
            file_ids:
              default: []
              maxItems: 100
              type: array
              items:
                type: string
                format: uuid
                pattern: >-
                  ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
            file_shapes:
              default: []
              maxItems: 100
              type: array
              items:
                type: object
                properties:
                  file_id:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  shape_id:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                required:
                  - file_id
                  - shape_id
                additionalProperties: false
          additionalProperties: false
        sort:
          default: newest
          type: string
          enum:
            - newest
            - oldest
            - created
            - modified
        date:
          default: {}
          type: object
          properties:
            after:
              type: string
              format: date-time
              pattern: >-
                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
            before:
              type: string
              format: date-time
              pattern: >-
                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
          additionalProperties: false
        limit:
          default: 50
          type: integer
          minimum: 1
          maximum: 200
        relationship_limit:
          default: 200
          type: integer
          minimum: 0
          maximum: 400
        cursor:
          type: string
          minLength: 1
          maxLength: 2048
        file_surface:
          type: string
          pattern: ^[a-z][a-z0-9]*(-[a-z0-9]+)*$
      additionalProperties: false
    http_context_explore_response:
      type: object
      properties:
        data:
          type: object
          properties:
            schema:
              type: string
              const: penumbra.project-context-explorer-page
            version:
              anyOf:
                - type: number
                  const: 1
                - type: number
                  const: 2
            entities:
              maxItems: 200
              type: array
              items:
                type: object
                properties:
                  id:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  type:
                    type: string
                  name:
                    anyOf:
                      - type: string
                      - type: 'null'
                  description:
                    anyOf:
                      - type: string
                      - type: 'null'
                  revision:
                    type: integer
                    exclusiveMinimum: 0
                    maximum: 9007199254740991
                  created_at:
                    type: string
                    format: date-time
                    pattern: >-
                      ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                  updated_at:
                    type: string
                    format: date-time
                    pattern: >-
                      ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                  shape:
                    anyOf:
                      - type: object
                        properties:
                          shape_id:
                            type: string
                            format: uuid
                            pattern: >-
                              ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                          artifact_digest:
                            type: string
                            pattern: ^sha256:[0-9a-f]{64}$
                          name:
                            anyOf:
                              - type: string
                                minLength: 1
                                maxLength: 1024
                              - type: 'null'
                          description:
                            anyOf:
                              - type: string
                                maxLength: 16384
                              - type: 'null'
                          type_description:
                            anyOf:
                              - type: string
                                maxLength: 16384
                              - type: 'null'
                        required:
                          - shape_id
                          - artifact_digest
                        additionalProperties: false
                      - type: 'null'
                  files:
                    maxItems: 32
                    type: array
                    items:
                      type: object
                      properties:
                        file_id:
                          type: string
                          format: uuid
                          pattern: >-
                            ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                        version_id:
                          type: string
                          format: uuid
                          pattern: >-
                            ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                        content_digest:
                          type: string
                          pattern: ^sha256:[0-9a-f]{64}$
                        chunk_id:
                          anyOf:
                            - type: string
                              format: uuid
                              pattern: >-
                                ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                            - type: 'null'
                        name:
                          anyOf:
                            - type: string
                              minLength: 1
                              maxLength: 1024
                            - type: 'null'
                        path:
                          anyOf:
                            - type: string
                              minLength: 1
                              maxLength: 4096
                            - type: 'null'
                      required:
                        - file_id
                        - version_id
                        - content_digest
                        - chunk_id
                      additionalProperties: false
                  time:
                    type: object
                    properties:
                      revision:
                        type: integer
                        exclusiveMinimum: 0
                        maximum: 9007199254740991
                      valid_time:
                        type: object
                        properties:
                          property:
                            type: string
                          valid_from:
                            type: string
                          valid_to:
                            type: string
                          how:
                            type: string
                        required:
                          - property
                          - valid_from
                          - valid_to
                          - how
                        additionalProperties: false
                      due_time:
                        type: object
                        properties:
                          property:
                            type: string
                          due_on:
                            type: string
                          how:
                            type: string
                        required:
                          - property
                          - due_on
                          - how
                        additionalProperties: false
                      source_time:
                        type: object
                        properties:
                          file_id:
                            type: string
                            format: uuid
                            pattern: >-
                              ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                          version_id:
                            type: string
                            format: uuid
                            pattern: >-
                              ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                          source_date:
                            anyOf:
                              - type: string
                              - type: 'null'
                        required:
                          - file_id
                          - version_id
                          - source_date
                        additionalProperties: false
                    required:
                      - revision
                    additionalProperties: false
                required:
                  - id
                  - type
                  - name
                  - description
                  - revision
                  - created_at
                  - updated_at
                  - shape
                  - files
                additionalProperties: false
            relationships:
              maxItems: 400
              type: array
              items:
                type: object
                properties:
                  id:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  source_node_id:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  target_node_id:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  type:
                    type: string
                  revision:
                    type: integer
                    exclusiveMinimum: 0
                    maximum: 9007199254740991
                  shape:
                    anyOf:
                      - type: object
                        properties:
                          shape_id:
                            type: string
                            format: uuid
                            pattern: >-
                              ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                          artifact_digest:
                            type: string
                            pattern: ^sha256:[0-9a-f]{64}$
                          name:
                            anyOf:
                              - type: string
                                minLength: 1
                                maxLength: 1024
                              - type: 'null'
                          description:
                            anyOf:
                              - type: string
                                maxLength: 16384
                              - type: 'null'
                          type_description:
                            anyOf:
                              - type: string
                                maxLength: 16384
                              - type: 'null'
                        required:
                          - shape_id
                          - artifact_digest
                        additionalProperties: false
                      - type: 'null'
                required:
                  - id
                  - source_node_id
                  - target_node_id
                  - type
                  - revision
                  - shape
                additionalProperties: false
            page:
              type: object
              properties:
                has_more:
                  type: boolean
                next_cursor:
                  anyOf:
                    - type: string
                    - type: 'null'
                relationships_truncated:
                  type: boolean
                mode:
                  type: string
                  enum:
                    - overview
                    - query
                loaded_count:
                  type: integer
                  minimum: 0
                  maximum: 200
                bounded:
                  type: boolean
                  const: true
              required:
                - has_more
                - next_cursor
                - relationships_truncated
              additionalProperties: false
          required:
            - schema
            - version
            - entities
            - relationships
            - page
          additionalProperties: false
      required:
        - data
      additionalProperties: false
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.